//----------------------------------------------------------------------------
// Solar PV unit (slave)
// Last revision 30 November 2009
// Licence: GNU GPL
// By Trystan Lea
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// Load Network library and create new instance
//----------------------------------------------------------------------------
#include "Network.h";
Network net;

//char array to store commands
char *cmd;

//Slave ID needs to be unique
//for each slave on your network
int slaveID = 43;

//----------------------------------------------------------------------------
//PV module variables
//----------------------------------------------------------------------------
int runPV = 100;      //Run PV calc every 100 ms
unsigned long pvtime; //Used to determine when pv calculations should run

double currentVperA = 0.133;                      //Calibration variables
double currentOffset = 0.5;
double voltageCal = 0.03232;

double currentA;                                  //Output variables
double currentB;
double voltage;
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Setup
//----------------------------------------------------------------------------
void setup()
{ 
  net.setTriStatePins(7,5);                      //Set tristate buffer pins

  pinMode(6,OUTPUT);                             //Battery full PV cutoff relay pin
  
  Serial.begin(9600);
}

//----------------------------------------------------------------------------
// Main loop
//----------------------------------------------------------------------------
void loop()
{
  
  //PV module calculations
  //-------------------------------------------------------------------------
  if ((millis()-pvtime)>runPV)
  {
    pvtime = millis(); //Reset timer
    currentA = (analogRead(3) * (5.0/1023) - currentOffset)/ currentVperA;
    currentB = (analogRead(4) * (5.0/1023) - currentOffset)/ currentVperA;
    voltage = analogRead(5)  * voltageCal;
    
    if (voltage>14.5) digitalWrite(6,HIGH);       //If battrey is full disconnect PV
    if (voltage<13.0) digitalWrite(6,LOW);        //else reconnect, 1.5V diff is to add a bit of hysterysis
  }
  //-------------------------------------------------------------------------
  
  //If serial line recieved
  if (net.available()) 
  {
    cmd = net.readCmd();
    //Check for standard slave commands
    SlaveCommands();           //Registers are set in here have a look in cmdList       
  } 
}




